'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var classNames = _interopDefault(require('classnames'));
var moment = _interopDefault(require('moment'));
var React = require('react');

var DatePicker = function DatePicker(props) {
  var _useState = React.useState(''),
    month = _useState[0],
    setMonth = _useState[1];
  var _useState2 = React.useState(''),
    year = _useState2[0],
    setYear = _useState2[1];
  var _useState3 = React.useState('2023-05-11'),
    date = _useState3[0],
    setDate = _useState3[1];
  var _useState4 = React.useState(),
    monthAllDate = _useState4[0],
    setMonthAlldate = _useState4[1];
  var _useState5 = React.useState(false),
    isShowPanel = _useState5[0],
    setShowPanel = _useState5[1];
  var _useState6 = React.useState(props.defaultDate),
    defaultDate = _useState6[0],
    setDefaultDate = _useState6[1];
  var _useState7 = React.useState(false),
    isSelected = _useState7[0],
    setSelected = _useState7[1];
  var arabicNumeralsToChinese = ['一', '二', '三', '四', '五', '六', '七', '八', '九', '十', '十一', '十二'];
  var generatorCurrentMonthData = function generatorCurrentMonthData(date) {
    var currentYear = moment(date).format("YYYY");
    var currentMonth = moment(date).format("MM");
    var currentMonthFirstWeekday = moment(currentYear + '-' + currentMonth + '-' + '01').weekday();
    var currentMonthDayCount = moment(date).daysInMonth();
    var currentMonthAllDate = [];
    if (currentMonthFirstWeekday === 0) currentMonthFirstWeekday = 7;
    //一排7天 预留6排空间
    for (var i = 0; i < 7 * 6; i++) {
      if (i < currentMonthFirstWeekday - 1) {
        currentMonthAllDate.push(null);
      } else if (i > currentMonthDayCount - 1 + currentMonthFirstWeekday - 1) {
        currentMonthAllDate.push(null);
      } else {
        var isDefault = defaultDate === currentYear + "-" + currentMonth + "-" + (i - currentMonthFirstWeekday + 2);
        //未来时间无法点击 置灰
        //disabled
        currentMonthAllDate.push({
          value: i - currentMonthFirstWeekday + 2,
          selected: false,
          isDefault: isDefault,
          disabled: false
        });
      }
    }
    return {
      year: currentYear,
      month: currentMonth,
      monthFirstWeekDay: currentMonthFirstWeekday,
      monthDayCount: currentMonthDayCount,
      monthAllDate: currentMonthAllDate
    };
  };
  //点击显示日期面板 需要初始化这个月的数据
  var showDatePickerPanel = function showDatePickerPanel() {
    //这个数据应该是当前界面上的数据
    var monthData = generatorCurrentMonthData(defaultDate);
    setYear(monthData.year);
    setMonth(monthData.month);
    setMonthAlldate(monthData.monthAllDate);
    setShowPanel(true);
    document.getElementsByTagName('body')[0].style.overflow = 'hidden';
  };
  //点击切换上个月
  var clickChangePreMonth = function clickChangePreMonth() {
    var preMonthDate = moment(date).subtract(1, 'month').format('YYYY-MM-DD');
    //用来生成月份数据的日期和当前选中的日期不是同一个日期
    var monthData = generatorCurrentMonthData(preMonthDate);
    setMonth(monthData.month);
    setYear(monthData.year);
    setDate(preMonthDate);
    setSelected(false);
    setMonthAlldate(monthData.monthAllDate);
  };
  //点击切换下个月 
  var clickChangeNextMonth = function clickChangeNextMonth() {
    console.log('1212');
    var preMonthDate = moment(date).add(1, 'month').format('YYYY-MM-DD');
    console.log(preMonthDate);
    var monthData = generatorCurrentMonthData(preMonthDate);
    setMonth(monthData.month);
    setYear(monthData.year);
    setDate(preMonthDate);
    setSelected(false);
    setMonthAlldate(monthData.monthAllDate);
  };
  //点击选中日期
  var clickSelectDate = function clickSelectDate(date) {
    setSelected(true);
    var newMonthAllDate = monthAllDate.map(function (item) {
      if (item !== null) {
        item.selected = false;
        if (item.value === date.value) {
          setDate(year + '-' + month + '-' + item.value);
          console.log(year + '年' + month + '月' + item.value + '日');
          item.selected = true;
        }
      }
      return item;
    });
    setMonthAlldate(newMonthAllDate);
  };
  //点击关闭当前面板
  var clickClosePanel = function clickClosePanel() {
    setSelected(false);
    setShowPanel(false);
    document.getElementsByTagName('body')[0].style.overflow = 'auto';
  };
  // 点击确认 修改default
  var clickConfirm = function clickConfirm() {
    setDefaultDate(date);
    if (props.change) {
      props.change(date);
    }
    setShowPanel(false);
    document.getElementsByTagName('body')[0].style.overflow = 'auto';
  };
  return React.createElement("div", null, React.createElement("div", {
    className: "date-select-content"
  }, React.createElement("div", {
    className: "date-label"
  }, props.label), React.createElement("div", {
    className: "date-input",
    onClick: function onClick() {
      showDatePickerPanel();
    }
  }, defaultDate)), isShowPanel ? React.createElement("div", {
    className: "datepicker-content"
  }, React.createElement("div", {
    className: "datepicker-container"
  }, React.createElement("div", {
    className: "datepicker-head"
  }, React.createElement("div", {
    className: "left-btn",
    onClick: clickChangePreMonth
  }), React.createElement("div", {
    className: "current-month"
  }, arabicNumeralsToChinese[parseInt(month) - 1] + ' 月'), React.createElement("div", {
    className: "right-btn",
    onClick: clickChangeNextMonth
  })), React.createElement("div", {
    className: "datepicker-body"
  }, React.createElement("ul", {
    className: "week"
  }, React.createElement("li", null, "\u4E00"), React.createElement("li", null, "\u4E8C"), React.createElement("li", null, "\u4E09"), React.createElement("li", null, "\u56DB"), React.createElement("li", null, "\u4E94"), React.createElement("li", null, "\u516D"), React.createElement("li", null, "\u65E5")), React.createElement("ul", {
    className: "date"
  }, monthAllDate.map(function (item) {
    if (item === null) {
      return React.createElement("li", null);
    }
    return React.createElement("li", {
      onClick: function onClick() {
        clickSelectDate(item);
      },
      className: classNames({
        'date-selected': item.selected,
        'date-default': item.isDefault,
        'date-disable': false
      })
    }, item.value);
  }))), React.createElement("div", {
    className: "datepicker-foot"
  }, React.createElement("div", {
    className: "year"
  }, year, "\u5E74"), React.createElement("div", {
    className: "btns"
  }, React.createElement("button", {
    onClick: function onClick() {
      clickClosePanel();
    },
    style: {
      marginRight: "10px"
    }
  }, "\u5173\u95ED"), React.createElement("button", {
    disabled: !isSelected,
    onClick: function onClick() {
      clickConfirm();
    }
  }, "\u786E\u5B9A"))))) : null);
};

exports.DatePicker = DatePicker;
//# sourceMappingURL=react-mobile-simple-datepicker.cjs.development.js.map
